#include "debug.h"

#ifndef PATHBAR_H
#define PATHBAR_H
#include <QLineEdit>
#include <QResizeEvent>
#include <peony-qt/controls/navigation-bar/advanced-location-bar.h>

namespace UKUIFileDialog {
class FileDialogPathBar : public QWidget//public QLineEdit//
{
    Q_OBJECT
public:
    explicit FileDialogPathBar(QWidget *parent = nullptr);
    ~FileDialogPathBar();
    void resizeEvent(QResizeEvent *e);
    Peony::AdvancedLocationBar *getPathBar();

Q_SIGNALS:
    void goToUriRequest(const QString &uri, bool addToHistory = true);
    void updateWindowLocationRequest(const QString &uri, bool addHistory, bool forceUpdate = false);
    void refreshRequest();
    void searchRequest(const QString &path, const QString &key);

public Q_SLOTS:
    void updateTableModel(bool isTable);
    void updatePath(const QString &uri);
private:
    Peony::AdvancedLocationBar *m_pathBar = nullptr;
};
}
#endif // PATHBAR_H
